#include <QtCore/QCoreApplication>
#include <QTextStream>
#include <QTimer>
#include <QLibrary>
#include <QTime>
#include <stdio.h>
#include <string.h>
#include <time.h>


#include "fftw3.h"

#include "cuda_runtime.h"
#include "cufft.h"

#include "CZ.h"
#include "math.h"
#include "float.h"

extern "C" __declspec(dllexport) int cuinfo();
extern "C" __declspec(dllexport) int cumemcpy();
extern "C" __declspec(dllexport) int cufftsolve();

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    QTextStream consol(stdout);
    QTime time1,time2;
    QString str;
    consol << "\n CUDA INFO \n"<<endl;
    cuinfo();
    consol << "\n CUDA MEMCPY \n"<<endl;
    cumemcpy();
    consol << "\n CUDA FFT \n"<<endl;
    cufftsolve();
    consol << "\n FFTW TEST \n"<<endl;
    int Nn = 8000000,k;
    void *Arre = NULL;
    double *data1;
    //fftw_complex *in, *out;
    data1 = (double*)malloc(sizeof(double)*Nn);
    // k = 0 data1[0*2] = data1[0] data1[0*2+1]=data1[1]
    // k = 1 data1[1*2] = data1[2] data1[1*2+1]=data1[3]
    // k = 2 data1[2*2] = data1[4] data1[2*2+1]=data1[5]
    for(k = 0;k<(Nn/2);k++){
    data1[k*2]  = sin(k*0.6)+sin(k*0.2);
    data1[k*2+1]= 0.;
    }
    time1 = time1.currentTime();
    //GetFFT(Arre,data1,Nn);
    time2 = time2.currentTime();

    str = time2.toString("hh:mm:ss.zzz") + "  " + time1.toString("hh:mm:ss.zzz");
    consol << "\nTime with dll" << str << endl;
    FILE *fp1, *fp2;
    fp1=fopen("fft_1.dat","w");
    fp2=fopen("fft_2.dat","w");

    for(k = 0;k<(Nn/2);k++){
    fprintf(fp1,"%f %f \n",data1[k*2],data1[k*2+1]);
    }
    /*********************************************************************************************/
    quint64 N = 5,i;
    fftw_complex *in, *out;
    fftw_plan p;
    in = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
    out = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * N);
    for(i =0 ; i< N; i++){
    in[i][0]=sin(i*2);
    in[i][1]=0.;
    }
    for(i =0 ; i< N; i++) printf("\n > %f + i %f",in[i][0],in[i][1]);

    consol << "\n from main"<<endl;
    time1 = time1.currentTime();
    p = fftw_plan_dft_1d(N, in, out, FFTW_FORWARD, FFTW_ESTIMATE);

    fftw_execute(p); /* repeat as needed */

    time2 = time2.currentTime();

    str = time2.toString("hh:mm:ss.zzz") + "  " + time1.toString("hh:mm:ss.zzz");
/*********************************************************************************************/

for(i =0 ; i< N; i++){
 consol << out[i][0] <<"+ i"<<out[i][1]<<endl;
// fprintf(fp1,"%f %f \n",out[i][0],out[i][1]);
}

/*********************************************************************************************/
consol << endl;
consol << "\nBegin" << str << endl;
fftw_destroy_plan(p);
/*********************************************************************************************/
    fclose(fp2); fclose(fp1);
    fftw_free(in); fftw_free(out);
    QTimer::singleShot(2000, &a, SLOT(quit()));
    return a.exec();
}
